require "defines"

energy_per_shot=1000 --constant related to amount of energy used in a single shot
check_interval=30 --interval between checks of players

--temporary workaround, every bullet type should be listed here, to provide interchangeability
--of items in same category
ammo_category={--cannot get ammocategory from anywhere
    ['basic-bullet-magazine']='bullet',
    ['piercing-bullet-magazine']='bullet',
}
category_ammo={}
for k,v in pairs(ammo_category) do
    category_ammo[v]=category_ammo[v] or {}
    table.insert(category_ammo[v],k)
end

function init()
    --creation of information tables about generated entities
    global.equip_data={}
    global.ammo_equip={}
    for k,v in pairs(game.item_prototypes) do
        if string.find(k,"automated%-equipment%-#") then
        --equipment is named as 'automated-equipment-#' ..ammo.name.. '#'
            local ammo
            _,_,ammo=string.find(k,"#(.+)#")
            global.equip_data[k]={
                ammo=ammo,
                magazine_size=game.get_item_prototype(ammo).magazine_size,
                }
            global.ammo_equip[ammo]=k
        end
    end
    --value for ontick counter
    global.next=1
end

function check_player(p)
    if not p.valid then return end
    local armor=p.get_inventory(defines.inventory.player_armor)[1]
    --check whether player has armorgrid
    if not (armor and armor.valid ) then print('fug') return end
    if not (armor and armor.valid_for_read and armor.has_grid) then return end
    local inv=p.get_inventory(defines.inventory.player_main)
    local equips=global.equip_data
    local per_shot=energy_per_shot
    local grid=armor.grid
    --search for relevant equipment in grid
    for _,e in pairs(grid.equipment) do 
        if equips[e.name] then
            local eq=equips[e.name]
            local menergy = eq.magazine_size*per_shot
            --is reload required
            if e.max_energy-e.energy> menergy then
                --is there ammo
                if inv.get_item_count(eq.ammo)>10 then
                    inv.remove{name=eq.ammo,count=1}
                    e.energy=e.energy+ menergy
                --is ammo critically low
                elseif e.energy<per_shot then
                    --is there other ammo of same category
                    for _,ammo in pairs(category_ammo[ammo_category[eq.ammo]]) do
                        if inv.get_item_count(ammo)>10 then
                            --swap to equivalent equipment
                            local pos=e.position
                            grid.take{equipment=e}
                            local e=grid.put{name=global.ammo_equip[ammo],position=pos}
                            inv.remove{name=ammo,count=1}
                            e.energy=e.energy+ equips[e.name].magazine_size*per_shot
                            break
                        end
                    end
                end
            end
        end
    end
end

script.on_init(function() init() end)
script.on_configuration_changed(function() init() end)

script.on_event(defines.events.on_tick, function(e)
    local int=check_interval
    local pls=game.players
    for i=global.next,#pls,int do
        check_player(pls[i])
    end
    global.next= (global.next % int) +1
end)
--script.on_event(defines.events.on_player_created,function(e)
    --local p=game.players[e.player_index]
    --p.insert( 'automated-equipment-#' ..'basic-bullet-magazine'.. '#')
    --p.insert('power-armor')
    --p.insert("fusion-reactor-equipment")
--end)
