local function gen_eq(name, ammo, sprite, attack_parameters,icon)
    --generates the equipment and item, no defaults
    local eq={
        type = "active-defense-equipment",
        name=name,
        --sprite ={filename="__core__/graphics/empty.png",
        sprite =sprite,
        shape ={width = 3,height = 2,type = "full"},
        energy_source ={
            type = "electric",
            usage_priority = "secondary-input",
            input_flow_limit = "1W",
            buffer_capacity = ''..((1+ammo.stack_size)*(ammo.magazine_size or 1)).. "kJ",
            },
        attack_parameters =attack_parameters,
        automatic = true,
        }
    eq.attack_parameters.ammo_type.energy_consumption = "1kJ"--this is needed because other amm_type info is copied from outside prototypes in the above code and those are not electric
    local it={--dummy item for combat equipment
        name = name,
        type = "item",
        icon = icon,
        placed_as_equipment_result = name,
        flags = {"goes-to-main-inventory"},
        subgroup = "equipment",
        order = "d[active-defense]-a[laser-defense-equipment]",
        stack_size = 20
        }
    return eq,it
end
local function generate_equipment(parameters)
--usable wrapper to gen_eq function
--also generates item
--parameters={ammo, sprite, attack_parameters, icon}
--ammo is mandatory value
    local p=parameters
    local ammo=p.ammo
    local name = 'automated-equipment-#' ..ammo.name.. '#'--this naming pattern is going to be used in script to detect our items
    local sprite= p.sprite or data.raw["active-defense-equipment"]["basic-laser-defense-equipment"].sprite
    
    local default_attack_par= {
        type = "projectile",
        ammo_category = p.ammo.ammo_type.category or "shotgun-shell",
        sound ={{filename = "__base__/sound/pump-shotgun.ogg",volume = 0.5}},
        projectile_center = {0, 0},
        projectile_creation_distance = 1,
        range = 20,
        cooldown = 30,
        ammo_type =ammo.ammo_type,
        }
    local aps=p.attack_parameters or {}
    for k,v in pairs(default_attack_par) do
        aps[k]=aps[k] or v
    end
    
    local icon = p.icon or "__base__/graphics/icons/shotgun-shell.png"
    
    return gen_eq(name,p.ammo,sprite,aps,icon)
end

local function generate_for_category(par)
--generate defence equipment for all the items of one category
--par = {name,ammo_category, sprite, attack_parameters, icon}
    local new={}
    for name,ammo in pairs(data.raw.ammo) do
        if ammo.ammo_type.category==par.ammo_category then
            par.ammo=ammo
            local e,i = generate_equipment(par)
            par.ammo=false
            table.insert(new,i)
            table.insert(new,e)
        end
    end
    return new
end

--making "personal-gun-defense"
local new_stuff=generate_for_category{
    ammo_category='bullet',
    sprite ={
		filename = "__Advanced_Personal_Defense__/graphics/equipment/personal-gun-defense.png",
		width = 96,
		height = 64,
		priority = "medium"
        },
    icon="__Advanced_Personal_Defense__/graphics/icons/advanced-laser-defense-equipment.png",
    attack_parameters={
        cooldown = 2,
        range = 14,
        sound = data.raw["ammo-turret"]["gun-turret"].attack_parameters.sound,
        },
    }
--put a recipe for a very first item generated
local recipe={
    type = "recipe",
    name = "personal-gun-defense",
    enabled = false,
    energy_required = 10,
    ingredients ={
        {"alien-artifact", 16},
       
        {"advanced-circuit", 5},   
        {"gun-turret", 6}
    },    
    result = new_stuff[1].name
}

data:extend(new_stuff)
data:extend{recipe}

--making "advanced-laser-defense-equipment"
--it probably shouldn't have been done like this, but I've already entangled the generation of items and entities and equipment above
--so I've thought I'd put almost everything in this file
local laser,item =generate_equipment{
    name="advanced-laser-defense-equipment",
    icon = "__Advanced_Personal_Defense__/graphics/icons/advanced-laser-defense-equipment.png",
    sprite={
		filename = "__Advanced_Personal_Defense__/graphics/equipment/advanced-laser-defense-equipment.png",
		width = 64,
		height = 96,
		priority = "medium",
        },
    ammo={
        stack_size=1,--dummy value
        name='johndoe',
        ammo_type={
            type = "projectile",
            category = "electric",
            energy_consumption = "8kJ",
            projectile = "laser",
            speed = 2,
            action ={
                type = "direct",
                action_delivery ={
                    type = "projectile",
                    projectile = "laser",
                    starting_speed = 0.28
                }
            }
        }
    },
    attack_parameters={
        type = "projectile",
		ammo_category = "electric",
		cooldown = 15,
		damage_modifier = 5,
		projectile_center = {0, 0},
		projectile_creation_distance = 0.6,
		range = 25,
		sound = data.raw["active-defense-equipment"]["basic-laser-defense-equipment"].attack_parameters.sound,
        }
}

--edit the generated prototypes
item.name="advanced-laser-defense-equipment"
item.placed_as_equipment_result = "advanced-laser-defense-equipment"
laser.name="advanced-laser-defense-equipment"
laser.energy_source={
		type = "electric",
		usage_priority = "secondary-input",
		buffer_capacity = "100kJ"
    }
laser.attack_parameters.ammo_type.energy_consumption = "8kJ"
laser.shape=={width = 2,height = 3,type = "full"}

--add recipe
local recipe={
    type = "recipe",
    name = "advanced-laser-defense-equipment",
    enabled = false,
    energy_required = 10,
    ingredients ={
        {"alien-artifact", 32},
        {"processing-unit", 1},
        {"effectivity-module-3", 1},   
        {"basic-laser-defense-equipment", 6}
        },
    result = "advanced-laser-defense-equipment"
    }
    
data:extend{item,laser,recipe}
